/[gentoo-x86]/eclass/eutils.eclass
Gentoo

Diff of /eclass/eutils.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.62 Revision 1.373
1# Copyright 1999-2003 Gentoo Technologies, Inc. 1# Copyright 1999-2011 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.62 2003/10/05 02:42:24 vapier Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.373 2011/12/16 23:38:41 vapier Exp $
4#
5# Author: Martin Schlemmer <azarah@gentoo.org>
6#
7# This eclass is for general purpose functions that most ebuilds
8# have to implement themselves.
9#
10# NB: If you add anything, please comment it!
11 4
12ECLASS=eutils 5# @ECLASS: eutils.eclass
13INHERITED="$INHERITED $ECLASS" 6# @MAINTAINER:
7# base-system@gentoo.org
8# @BLURB: many extra (but common) functions that are used in ebuilds
9# @DESCRIPTION:
10# The eutils eclass contains a suite of functions that complement
11# the ones that ebuild.sh already contain. The idea is that the functions
12# are not required in all ebuilds but enough utilize them to have a common
13# home rather than having multiple ebuilds implementing the same thing.
14#
15# Due to the nature of this eclass, some functions may have maintainers
16# different from the overall eclass!
14 17
15newdepend "!bootstrap? ( sys-devel/patch )" 18if [[ ${___ECLASS_ONCE_EUTILS} != "recur -_+^+_- spank" ]] ; then
19___ECLASS_ONCE_EUTILS="recur -_+^+_- spank"
20
21inherit multilib portability user
16 22
17DESCRIPTION="Based on the ${ECLASS} eclass" 23DESCRIPTION="Based on the ${ECLASS} eclass"
18 24
19# This function generate linker scripts in /usr/lib for dynamic 25if has "${EAPI:-0}" 0 1 2; then
20# libs in /lib. This is to fix linking problems when you have
21# the .so in /lib, and the .a in /usr/lib. What happens is that
22# in some cases when linking dynamic, the .a in /usr/lib is used
23# instead of the .so in /lib due to gcc/libtool tweaking ld's
24# library search path. This cause many builds to fail.
25# See bug #4411 for more info.
26#
27# To use, simply call:
28#
29# gen_usr_ldscript libfoo.so
30#
31# Note that you should in general use the unversioned name of
32# the library, as ldconfig should usually update it correctly
33# to point to the latest version of the library present.
34#
35# <azarah@gentoo.org> (26 Oct 2002)
36#
37gen_usr_ldscript() {
38 26
39 # Just make sure it exists 27# @FUNCTION: epause
40 dodir /usr/lib 28# @USAGE: [seconds]
41 29# @DESCRIPTION:
42 cat > ${D}/usr/lib/$1 <<"END_LDSCRIPT" 30# Sleep for the specified number of seconds (default of 5 seconds). Useful when
43/* GNU ld script 31# printing a message the user should probably be reading and often used in
44 Because Gentoo have critical dynamic libraries 32# conjunction with the ebeep function. If the EPAUSE_IGNORE env var is set,
45 in /lib, and the static versions in /usr/lib, we 33# don't wait at all. Defined in EAPIs 0 1 and 2.
46 need to have a "fake" dynamic lib in /usr/lib, 34epause() {
47 otherwise we run into linking problems. 35 [[ -z ${EPAUSE_IGNORE} ]] && sleep ${1:-5}
48 See bug #4411 on http://bugs.gentoo.org/ for
49 more info. */
50GROUP ( /lib/libxxx )
51END_LDSCRIPT
52
53 dosed "s:libxxx:$1:" /usr/lib/$1
54
55 return 0
56} 36}
57 37
58# Simple function to draw a line consisting of '=' the same length as $* 38# @FUNCTION: ebeep
59# 39# @USAGE: [number of beeps]
60# <azarah@gentoo.org> (11 Nov 2002) 40# @DESCRIPTION:
61# 41# Issue the specified number of beeps (default of 5 beeps). Useful when
62draw_line() { 42# printing a message the user should probably be reading and often used in
43# conjunction with the epause function. If the EBEEP_IGNORE env var is set,
44# don't beep at all. Defined in EAPIs 0 1 and 2.
45ebeep() {
63 local i=0 46 local n
64 local str_length="" 47 if [[ -z ${EBEEP_IGNORE} ]] ; then
65 48 for ((n=1 ; n <= ${1:-5} ; n++)) ; do
66 # Handle calls that do not have args, or wc not being installed ...
67 if [ -z "$1" -o ! -x "$(which wc 2>/dev/null)" ]
68 then
69 echo "==============================================================="
70 return 0
71 fi
72
73 # Get the length of $*
74 str_length="$(echo -n "$*" | wc -m)"
75
76 while [ "$i" -lt "${str_length}" ]
77 do
78 echo -n "=" 49 echo -ne "\a"
79 50 sleep 0.1 &>/dev/null ; sleep 0,1 &>/dev/null
80 i=$((i + 1)) 51 echo -ne "\a"
52 sleep 1
81 done 53 done
54 fi
55}
82 56
83 echo 57else
84 58
59ebeep() {
60 ewarn "QA Notice: ebeep is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
61}
62
63epause() {
64 ewarn "QA Notice: epause is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
65}
66
67fi
68
69# @FUNCTION: eqawarn
70# @USAGE: [message]
71# @DESCRIPTION:
72# Proxy to ewarn for package managers that don't provide eqawarn and use the PM
73# implementation if available. Reuses PORTAGE_ELOG_CLASSES as set by the dev
74# profile.
75if ! declare -F eqawarn >/dev/null ; then
76 eqawarn() {
77 has qa ${PORTAGE_ELOG_CLASSES} && ewarn "$@"
78 :
79 }
80fi
81
82# @FUNCTION: ecvs_clean
83# @USAGE: [list of dirs]
84# @DESCRIPTION:
85# Remove CVS directories recursiveley. Useful when a source tarball contains
86# internal CVS directories. Defaults to $PWD.
87ecvs_clean() {
88 [[ -z $* ]] && set -- .
89 find "$@" -type d -name 'CVS' -prune -print0 | xargs -0 rm -rf
90 find "$@" -type f -name '.cvs*' -print0 | xargs -0 rm -rf
91}
92
93# @FUNCTION: esvn_clean
94# @USAGE: [list of dirs]
95# @DESCRIPTION:
96# Remove .svn directories recursiveley. Useful when a source tarball contains
97# internal Subversion directories. Defaults to $PWD.
98esvn_clean() {
99 [[ -z $* ]] && set -- .
100 find "$@" -type d -name '.svn' -prune -print0 | xargs -0 rm -rf
101}
102
103# @FUNCTION: estack_push
104# @USAGE: <stack> [items to push]
105# @DESCRIPTION:
106# Push any number of items onto the specified stack. Pick a name that
107# is a valid variable (i.e. stick to alphanumerics), and push as many
108# items as you like onto the stack at once.
109#
110# The following code snippet will echo 5, then 4, then 3, then ...
111# @CODE
112# estack_push mystack 1 2 3 4 5
113# while estack_pop mystack i ; do
114# echo "${i}"
115# done
116# @CODE
117estack_push() {
118 [[ $# -eq 0 ]] && die "estack_push: incorrect # of arguments"
119 local stack_name="__ESTACK_$1__" ; shift
120 eval ${stack_name}+=\( \"\$@\" \)
121}
122
123# @FUNCTION: estack_pop
124# @USAGE: <stack> [variable]
125# @DESCRIPTION:
126# Pop a single item off the specified stack. If a variable is specified,
127# the popped item is stored there. If no more items are available, return
128# 1, else return 0. See estack_push for more info.
129estack_pop() {
130 [[ $# -eq 0 || $# -gt 2 ]] && die "estack_pop: incorrect # of arguments"
131
132 # We use the fugly __estack_xxx var names to avoid collision with
133 # passing back the return value. If we used "local i" and the
134 # caller ran `estack_pop ... i`, we'd end up setting the local
135 # copy of "i" rather than the caller's copy. The __estack_xxx
136 # garbage is preferable to using $1/$2 everywhere as that is a
137 # bit harder to read.
138 local __estack_name="__ESTACK_$1__" ; shift
139 local __estack_retvar=$1 ; shift
140 eval local __estack_i=\${#${__estack_name}[@]}
141 # Don't warn -- let the caller interpret this as a failure
142 # or as normal behavior (akin to `shift`)
143 [[ $(( --__estack_i )) -eq -1 ]] && return 1
144
145 if [[ -n ${__estack_retvar} ]] ; then
146 eval ${__estack_retvar}=\"\${${__estack_name}[${__estack_i}]}\"
147 fi
148 eval unset ${__estack_name}[${__estack_i}]
149}
150
151# @FUNCTION: eshopts_push
152# @USAGE: [options to `set` or `shopt`]
153# @DESCRIPTION:
154# Often times code will want to enable a shell option to change code behavior.
155# Since changing shell options can easily break other pieces of code (which
156# assume the default state), eshopts_push is used to (1) push the current shell
157# options onto a stack and (2) pass the specified arguments to set.
158#
159# If the first argument is '-s' or '-u', we assume you want to call `shopt`
160# rather than `set` as there are some options only available via that.
161#
162# A common example is to disable shell globbing so that special meaning/care
163# may be used with variables/arguments to custom functions. That would be:
164# @CODE
165# eshopts_push -o noglob
166# for x in ${foo} ; do
167# if ...some check... ; then
168# eshopts_pop
85 return 0 169# return 0
170# fi
171# done
172# eshopts_pop
173# @CODE
174eshopts_push() {
175 # have to assume __ESHOPTS_SAVE__ isn't screwed with
176 # as a `declare -a` here will reset its value
177 if [[ $1 == -[su] ]] ; then
178 estack_push eshopts "$(shopt -p)"
179 [[ $# -eq 0 ]] && return 0
180 shopt "$@" || die "${FUNCNAME}: bad options to shopt: $*"
181 else
182 estack_push eshopts $-
183 [[ $# -eq 0 ]] && return 0
184 set "$@" || die "${FUNCNAME}: bad options to set: $*"
185 fi
86} 186}
87 187
88# Default directory where patches are located 188# @FUNCTION: eshopts_pop
189# @USAGE:
190# @DESCRIPTION:
191# Restore the shell options to the state saved with the corresponding
192# eshopts_push call. See that function for more details.
193eshopts_pop() {
194 local s
195 estack_pop eshopts s || die "${FUNCNAME}: unbalanced push"
196 if [[ ${s} == "shopt -"* ]] ; then
197 eval "${s}" || die "${FUNCNAME}: sanity: invalid shopt options: ${s}"
198 else
199 set +$- || die "${FUNCNAME}: sanity: invalid shell settings: $-"
200 set -${s} || die "${FUNCNAME}: sanity: unable to restore saved shell settings: ${s}"
201 fi
202}
203
204# @FUNCTION: eumask_push
205# @USAGE: <new umask>
206# @DESCRIPTION:
207# Set the umask to the new value specified while saving the previous
208# value onto a stack. Useful for temporarily changing the umask.
209eumask_push() {
210 estack_push eumask "$(umask)"
211 umask "$@" || die "${FUNCNAME}: bad options to umask: $*"
212}
213
214# @FUNCTION: eumask_pop
215# @USAGE:
216# @DESCRIPTION:
217# Restore the previous umask state.
218eumask_pop() {
219 local s
220 estack_pop eumask s || die "${FUNCNAME}: unbalanced push"
221 umask ${s} || die "${FUNCNAME}: sanity: could not restore umask: ${s}"
222}
223
224# @VARIABLE: EPATCH_SOURCE
225# @DESCRIPTION:
226# Default directory to search for patches.
89EPATCH_SOURCE="${WORKDIR}/patch" 227EPATCH_SOURCE="${WORKDIR}/patch"
90# Default extension for patches 228# @VARIABLE: EPATCH_SUFFIX
229# @DESCRIPTION:
230# Default extension for patches (do not prefix the period yourself).
91EPATCH_SUFFIX="patch.bz2" 231EPATCH_SUFFIX="patch.bz2"
232# @VARIABLE: EPATCH_OPTS
233# @DESCRIPTION:
92# Default options for patch 234# Default options for patch:
235# @CODE
93# Set -g0 to keep RCS, ClearCase, Perforce and SCCS happy. Bug #24571 236# -g0 - keep RCS, ClearCase, Perforce and SCCS happy #24571
94EPATCH_OPTS="-g0" 237# --no-backup-if-mismatch - do not leave .orig files behind
238# -E - automatically remove empty files
239# @CODE
240EPATCH_OPTS="-g0 -E --no-backup-if-mismatch"
241# @VARIABLE: EPATCH_EXCLUDE
242# @DESCRIPTION:
95# List of patches not to apply. Not this is only file names, 243# List of patches not to apply. Note this is only file names,
96# and not the full path .. 244# and not the full path. Globs accepted.
97EPATCH_EXCLUDE="" 245EPATCH_EXCLUDE=""
246# @VARIABLE: EPATCH_SINGLE_MSG
247# @DESCRIPTION:
98# Change the printed message for a single patch. 248# Change the printed message for a single patch.
99EPATCH_SINGLE_MSG="" 249EPATCH_SINGLE_MSG=""
100# Force applying bulk patches even if not following the style: 250# @VARIABLE: EPATCH_MULTI_MSG
101# 251# @DESCRIPTION:
102# ??_${ARCH}_foo.${EPATCH_SUFFIX} 252# Change the printed message for multiple patches.
103# 253EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..."
254# @VARIABLE: EPATCH_FORCE
255# @DESCRIPTION:
256# Only require patches to match EPATCH_SUFFIX rather than the extended
257# arch naming style.
104EPATCH_FORCE="no" 258EPATCH_FORCE="no"
105 259
106# This function is for bulk patching, or in theory for just one 260# @FUNCTION: epatch
107# or two patches. 261# @USAGE: [patches] [dirs of patches]
262# @DESCRIPTION:
263# epatch is designed to greatly simplify the application of patches. It can
264# process patch files directly, or directories of patches. The patches may be
265# compressed (bzip/gzip/etc...) or plain text. You generally need not specify
266# the -p option as epatch will automatically attempt -p0 to -p5 until things
267# apply successfully.
108# 268#
109# It should work with .bz2, .gz, .zip and plain text patches. 269# If you do not specify any options, then epatch will default to the directory
110# Currently all patches should be the same format. 270# specified by EPATCH_SOURCE.
111# 271#
112# You do not have to specify '-p' option to patch, as it will 272# When processing directories, epatch will apply all patches that match:
113# try with -p0 to -p5 until it succeed, or fail at -p5. 273# @CODE
114# 274# if ${EPATCH_FORCE} != "yes"
115# Above EPATCH_* variables can be used to control various defaults,
116# bug they should be left as is to ensure an ebuild can rely on
117# them for.
118#
119# Patches are applied in current directory.
120#
121# Bulk Patches should preferibly have the form of:
122#
123# ??_${ARCH}_foo.${EPATCH_SUFFIX} 275# ??_${ARCH}_foo.${EPATCH_SUFFIX}
276# else
277# *.${EPATCH_SUFFIX}
278# @CODE
279# The leading ?? are typically numbers used to force consistent patch ordering.
280# The arch field is used to apply patches only for the host architecture with
281# the special value of "all" means apply for everyone. Note that using values
282# other than "all" is highly discouraged -- you should apply patches all the
283# time and let architecture details be detected at configure/compile time.
124# 284#
125# For example: 285# If EPATCH_SUFFIX is empty, then no period before it is implied when searching
286# for patches to apply.
126# 287#
127# 01_all_misc-fix.patch.bz2 288# Refer to the other EPATCH_xxx variables for more customization of behavior.
128# 02_sparc_another-fix.patch.bz2
129#
130# This ensures that there are a set order, and you can have ARCH
131# specific patches.
132#
133# If you however give an argument to epatch(), it will treat it as a
134# single patch that need to be applied if its a file. If on the other
135# hand its a directory, it will set EPATCH_SOURCE to this.
136#
137# <azarah@gentoo.org> (10 Nov 2002)
138#
139epatch() { 289epatch() {
140 local PIPE_CMD="" 290 _epatch_draw_line() {
141 local STDERR_TARGET="${T}/$$.out" 291 # create a line of same length as input string
142 local PATCH_TARGET="${T}/$$.patch" 292 [[ -z $1 ]] && set "$(printf "%65s" '')"
143 local PATCH_SUFFIX="" 293 echo "${1//?/=}"
294 }
295
296 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402
297
298 # Let the rest of the code process one user arg at a time --
299 # each arg may expand into multiple patches, and each arg may
300 # need to start off with the default global EPATCH_xxx values
301 if [[ $# -gt 1 ]] ; then
302 local m
303 for m in "$@" ; do
304 epatch "${m}"
305 done
306 return 0
307 fi
308
144 local SINGLE_PATCH="no" 309 local SINGLE_PATCH="no"
145 local x="" 310 # no args means process ${EPATCH_SOURCE}
311 [[ $# -eq 0 ]] && set -- "${EPATCH_SOURCE}"
146 312
147 if [ "$#" -gt 1 ] 313 if [[ -f $1 ]] ; then
148 then
149 eerror "Invalid arguments to epatch()"
150 die "Invalid arguments to epatch()"
151 fi
152
153 if [ -n "$1" -a -f "$1" ]
154 then
155 SINGLE_PATCH="yes" 314 SINGLE_PATCH="yes"
156 315 set -- "$1"
157 local EPATCH_SOURCE="$1" 316 # Use the suffix from the single patch (localize it); the code
317 # below will find the suffix for us
158 local EPATCH_SUFFIX="${1##*\.}" 318 local EPATCH_SUFFIX=$1
159 319
160 elif [ -n "$1" -a -d "$1" ] 320 elif [[ -d $1 ]] ; then
161 then 321 # Some people like to make dirs of patches w/out suffixes (vim)
162 # Allow no extension if EPATCH_FORCE=yes ... used by vim for example ... 322 set -- "$1"/*${EPATCH_SUFFIX:+."${EPATCH_SUFFIX}"}
163 if [ "${EPATCH_FORCE}" = "yes" ] && [ -z "${EPATCH_SUFFIX}" ] 323
324 elif [[ -f ${EPATCH_SOURCE}/$1 ]] ; then
325 # Re-use EPATCH_SOURCE as a search dir
326 epatch "${EPATCH_SOURCE}/$1"
327 return $?
328
329 else
330 # sanity check ... if it isn't a dir or file, wtf man ?
331 [[ $# -ne 0 ]] && EPATCH_SOURCE=$1
332 echo
333 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:"
334 eerror
335 eerror " ${EPATCH_SOURCE}"
336 eerror " ( ${EPATCH_SOURCE##*/} )"
337 echo
338 die "Cannot find \$EPATCH_SOURCE!"
339 fi
340
341 local PIPE_CMD
342 case ${EPATCH_SUFFIX##*\.} in
343 xz) PIPE_CMD="xz -dc" ;;
344 lzma) PIPE_CMD="lzma -dc" ;;
345 bz2) PIPE_CMD="bzip2 -dc" ;;
346 gz|Z|z) PIPE_CMD="gzip -dc" ;;
347 ZIP|zip) PIPE_CMD="unzip -p" ;;
348 *) ;;
349 esac
350
351 [[ ${SINGLE_PATCH} == "no" ]] && einfo "${EPATCH_MULTI_MSG}"
352
353 local x
354 for x in "$@" ; do
355 # If the patch dir given contains subdirs, or our EPATCH_SUFFIX
356 # didn't match anything, ignore continue on
357 [[ ! -f ${x} ]] && continue
358
359 local patchname=${x##*/}
360
361 # Apply single patches, or forced sets of patches, or
362 # patches with ARCH dependant names.
363 # ???_arch_foo.patch
364 # Else, skip this input altogether
365 local a=${patchname#*_} # strip the ???_
366 a=${a%%_*} # strip the _foo.patch
367 if ! [[ ${SINGLE_PATCH} == "yes" || \
368 ${EPATCH_FORCE} == "yes" || \
369 ${a} == all || \
370 ${a} == ${ARCH} ]]
164 then 371 then
165 local EPATCH_SOURCE="$1/*" 372 continue
373 fi
374
375 # Let people filter things dynamically
376 if [[ -n ${EPATCH_EXCLUDE} ]] ; then
377 # let people use globs in the exclude
378 eshopts_push -o noglob
379
380 local ex
381 for ex in ${EPATCH_EXCLUDE} ; do
382 if [[ ${patchname} == ${ex} ]] ; then
383 eshopts_pop
384 continue 2
385 fi
386 done
387
388 eshopts_pop
389 fi
390
391 if [[ ${SINGLE_PATCH} == "yes" ]] ; then
392 if [[ -n ${EPATCH_SINGLE_MSG} ]] ; then
393 einfo "${EPATCH_SINGLE_MSG}"
394 else
395 einfo "Applying ${patchname} ..."
396 fi
166 else 397 else
167 local EPATCH_SOURCE="$1/*.${EPATCH_SUFFIX}" 398 einfo " ${patchname} ..."
399 fi
400
401 # most of the time, there will only be one run per unique name,
402 # but if there are more, make sure we get unique log filenames
403 local STDERR_TARGET="${T}/${patchname}.out"
404 if [[ -e ${STDERR_TARGET} ]] ; then
405 STDERR_TARGET="${T}/${patchname}-$$.out"
406 fi
407
408 printf "***** %s *****\nPWD: %s\n\n" "${patchname}" "${PWD}" > "${STDERR_TARGET}"
409
410 # Decompress the patch if need be
411 local count=0
412 local PATCH_TARGET
413 if [[ -n ${PIPE_CMD} ]] ; then
414 PATCH_TARGET="${T}/$$.patch"
415 echo "PIPE_COMMAND: ${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> "${STDERR_TARGET}"
416
417 if ! (${PIPE_CMD} "${x}" > "${PATCH_TARGET}") >> "${STDERR_TARGET}" 2>&1 ; then
418 echo
419 eerror "Could not extract patch!"
420 #die "Could not extract patch!"
421 count=5
422 break
168 fi 423 fi
424 else
425 PATCH_TARGET=${x}
426 fi
427
428 # Check for absolute paths in patches. If sandbox is disabled,
429 # people could (accidently) patch files in the root filesystem.
430 # Or trigger other unpleasantries #237667. So disallow -p0 on
431 # such patches.
432 local abs_paths=$(egrep -n '^[-+]{3} /' "${PATCH_TARGET}" | awk '$2 != "/dev/null" { print }')
433 if [[ -n ${abs_paths} ]] ; then
434 count=1
435 printf "NOTE: skipping -p0 due to absolute paths in patch:\n%s\n" "${abs_paths}" >> "${STDERR_TARGET}"
436 fi
437 # Similar reason, but with relative paths.
438 local rel_paths=$(egrep -n '^[-+]{3} [^ ]*[.][.]/' "${PATCH_TARGET}")
439 if [[ -n ${rel_paths} ]] ; then
440 eqawarn "QA Notice: Your patch uses relative paths '../'."
441 eqawarn " In the future this will cause a failure."
442 eqawarn "${rel_paths}"
443 fi
444
445 # Dynamically detect the correct -p# ... i'm lazy, so shoot me :/
446 while [[ ${count} -lt 5 ]] ; do
447 # Generate some useful debug info ...
448 (
449 _epatch_draw_line "***** ${patchname} *****"
450 echo
451 echo "PATCH COMMAND: patch -p${count} ${EPATCH_OPTS} < '${PATCH_TARGET}'"
452 echo
453 _epatch_draw_line "***** ${patchname} *****"
454 patch -p${count} ${EPATCH_OPTS} --dry-run -f < "${PATCH_TARGET}" 2>&1
455 ret=$?
456 echo
457 echo "patch program exited with status ${ret}"
458 exit ${ret}
459 ) >> "${STDERR_TARGET}"
460
461 if [ $? -eq 0 ] ; then
462 (
463 _epatch_draw_line "***** ${patchname} *****"
464 echo
465 echo "ACTUALLY APPLYING ${patchname} ..."
466 echo
467 _epatch_draw_line "***** ${patchname} *****"
468 patch -p${count} ${EPATCH_OPTS} < "${PATCH_TARGET}" 2>&1
469 ret=$?
470 echo
471 echo "patch program exited with status ${ret}"
472 exit ${ret}
473 ) >> "${STDERR_TARGET}"
474
475 if [ $? -ne 0 ] ; then
476 echo
477 eerror "A dry-run of patch command succeeded, but actually"
478 eerror "applying the patch failed!"
479 #die "Real world sux compared to the dreamworld!"
480 count=5
481 fi
482 break
483 fi
484
485 : $(( count++ ))
486 done
487
488 # if we had to decompress the patch, delete the temp one
489 if [[ -n ${PIPE_CMD} ]] ; then
490 rm -f "${PATCH_TARGET}"
491 fi
492
493 if [[ ${count} -ge 5 ]] ; then
494 echo
495 eerror "Failed Patch: ${patchname} !"
496 eerror " ( ${PATCH_TARGET} )"
497 eerror
498 eerror "Include in your bugreport the contents of:"
499 eerror
500 eerror " ${STDERR_TARGET}"
501 echo
502 die "Failed Patch: ${patchname}!"
503 fi
504
505 # if everything worked, delete the patch log
506 rm -f "${STDERR_TARGET}"
507 eend 0
508 done
509
510 [[ ${SINGLE_PATCH} == "no" ]] && einfo "Done with patching"
511 : # everything worked
512}
513
514# @FUNCTION: epatch_user
515# @USAGE:
516# @DESCRIPTION:
517# Applies user-provided patches to the source tree. The patches are
518# taken from /etc/portage/patches/<CATEGORY>/<PF|P|PN>/, where the first
519# of these three directories to exist will be the one to use, ignoring
520# any more general directories which might exist as well.
521#
522# User patches are intended for quick testing of patches without ebuild
523# modifications, as well as for permanent customizations a user might
524# desire. Obviously, there can be no official support for arbitrarily
525# patched ebuilds. So whenever a build log in a bug report mentions that
526# user patches were applied, the user should be asked to reproduce the
527# problem without these.
528#
529# Not all ebuilds do call this function, so placing patches in the
530# stated directory might or might not work, depending on the package and
531# the eclasses it inherits and uses. It is safe to call the function
532# repeatedly, so it is always possible to add a call at the ebuild
533# level. The first call is the time when the patches will be
534# applied.
535#
536# Ideally, this function should be called after gentoo-specific patches
537# have been applied, so that their code can be modified as well, but
538# before calls to e.g. eautoreconf, as the user patches might affect
539# autotool input files as well.
540epatch_user() {
541 [[ $# -ne 0 ]] && die "epatch_user takes no options"
542
543 # Allow multiple calls to this function; ignore all but the first
544 local applied="${T}/epatch_user.applied"
545 [[ -e ${applied} ]] && return 2
546
547 # don't clobber any EPATCH vars that the parent might want
548 local EPATCH_SOURCE check base=${PORTAGE_CONFIGROOT%/}/etc/portage/patches
549 for check in {${CATEGORY}/${PF},${CATEGORY}/${P},${CATEGORY}/${PN}}; do
550 EPATCH_SOURCE=${base}/${CTARGET}/${check}
551 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${CHOST}/${check}
552 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${check}
553 if [[ -d ${EPATCH_SOURCE} ]] ; then
554 EPATCH_SOURCE=${EPATCH_SOURCE} \
555 EPATCH_SUFFIX="patch" \
556 EPATCH_FORCE="yes" \
557 EPATCH_MULTI_MSG="Applying user patches from ${EPATCH_SOURCE} ..." \
558 epatch
559 echo "${EPATCH_SOURCE}" > "${applied}"
560 return 0
561 fi
562 done
563 echo "none" > "${applied}"
564 return 1
565}
566
567# @FUNCTION: emktemp
568# @USAGE: [temp dir]
569# @DESCRIPTION:
570# Cheap replacement for when debianutils (and thus mktemp)
571# does not exist on the users system.
572emktemp() {
573 local exe="touch"
574 [[ $1 == -d ]] && exe="mkdir" && shift
575 local topdir=$1
576
577 if [[ -z ${topdir} ]] ; then
578 [[ -z ${T} ]] \
579 && topdir="/tmp" \
580 || topdir=${T}
581 fi
582
583 if ! type -P mktemp > /dev/null ; then
584 # system lacks `mktemp` so we have to fake it
585 local tmp=/
586 while [[ -e ${tmp} ]] ; do
587 tmp=${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM}
588 done
589 ${exe} "${tmp}" || ${exe} -p "${tmp}"
590 echo "${tmp}"
169 else 591 else
170 if [ ! -d ${EPATCH_SOURCE} ] 592 # the args here will give slightly wierd names on BSD,
171 then 593 # but should produce a usable file on all userlands
172 if [ -n "$1" -a "${EPATCH_SOURCE}" = "${WORKDIR}/patch" ] 594 if [[ ${exe} == "touch" ]] ; then
173 then 595 TMPDIR="${topdir}" mktemp -t tmp.XXXXXXXXXX
174 EPATCH_SOURCE="$1"
175 fi
176
177 echo
178 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:"
179 eerror
180 eerror " ${EPATCH_SOURCE}"
181 echo
182 die "Cannot find \$EPATCH_SOURCE!"
183 fi
184
185 local EPATCH_SOURCE="${EPATCH_SOURCE}/*.${EPATCH_SUFFIX}"
186 fi
187
188 case ${EPATCH_SUFFIX##*\.} in
189 bz2)
190 PIPE_CMD="bzip2 -dc"
191 PATCH_SUFFIX="bz2"
192 ;;
193 gz|Z|z)
194 PIPE_CMD="gzip -dc"
195 PATCH_SUFFIX="gz"
196 ;;
197 ZIP|zip)
198 PIPE_CMD="unzip -p"
199 PATCH_SUFFIX="zip"
200 ;;
201 *)
202 PIPE_CMD="cat"
203 PATCH_SUFFIX="patch"
204 ;;
205 esac
206
207 if [ "${SINGLE_PATCH}" = "no" ]
208 then
209 einfo "Applying various patches (bugfixes/updates)..."
210 fi
211 for x in ${EPATCH_SOURCE}
212 do
213 # New ARCH dependant patch naming scheme...
214 #
215 # ???_arch_foo.patch
216 #
217 if [ -f ${x} ] && \
218 ([ "${SINGLE_PATCH}" = "yes" -o "${x/_all_}" != "${x}" -o "`eval echo \$\{x/_${ARCH}_\}`" != "${x}" ] || \
219 [ "${EPATCH_FORCE}" = "yes" ])
220 then
221 local count=0
222 local popts="${EPATCH_OPTS}"
223
224 if [ -n "${EPATCH_EXCLUDE}" ]
225 then
226 if [ "`eval echo \$\{EPATCH_EXCLUDE/${x##*/}\}`" != "${EPATCH_EXCLUDE}" ]
227 then
228 continue
229 fi
230 fi
231
232 if [ "${SINGLE_PATCH}" = "yes" ]
233 then
234 if [ -n "${EPATCH_SINGLE_MSG}" ]
235 then
236 einfo "${EPATCH_SINGLE_MSG}"
237 else
238 einfo "Applying ${x##*/}..."
239 fi
240 else
241 einfo " ${x##*/}..."
242 fi
243
244 echo "***** ${x##*/} *****" > ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
245 echo >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
246
247 # Allow for prefix to differ ... im lazy, so shoot me :/
248 while [ "${count}" -lt 5 ]
249 do
250 # Generate some useful debug info ...
251 draw_line "***** ${x##*/} *****" >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
252 echo >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
253
254 if [ "${PATCH_SUFFIX}" != "patch" ]
255 then
256 echo -n "PIPE_COMMAND: " >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
257 echo "${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
258 else
259 PATCH_TARGET="${x}"
260 fi
261
262 echo -n "PATCH COMMAND: " >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
263 echo "patch ${popts} -p${count} < ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
264
265 echo >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
266 draw_line "***** ${x##*/} *****" >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
267
268 if [ "${PATCH_SUFFIX}" != "patch" ]
269 then
270 if ! (${PIPE_CMD} ${x} > ${PATCH_TARGET}) >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/} 2>&1
271 then
272 echo
273 eerror "Could not extract patch!"
274 #die "Could not extract patch!"
275 count=5
276 break
277 fi
278 fi
279
280 if (cat ${PATCH_TARGET} | patch ${popts} --dry-run -f -p${count}) >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/} 2>&1
281 then
282 draw_line "***** ${x##*/} *****" > ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real
283 echo >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real
284 echo "ACTUALLY APPLYING ${x##*/}..." >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real
285 echo >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real
286 draw_line "***** ${x##*/} *****" >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real
287
288 cat ${PATCH_TARGET} | patch ${popts} -p${count} >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real 2>&1
289
290 if [ "$?" -ne 0 ]
291 then
292 cat ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
293 echo
294 eerror "A dry-run of patch command succeeded, but actually"
295 eerror "applying the patch failed!"
296 #die "Real world sux compared to the dreamworld!"
297 count=5
298 fi
299
300 rm -f ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real
301
302 break
303 fi
304
305 count=$((count + 1))
306 done
307
308 if [ "${PATCH_SUFFIX}" != "patch" ]
309 then
310 rm -f ${PATCH_TARGET}
311 fi
312
313 if [ "${count}" -eq 5 ]
314 then
315 echo
316 eerror "Failed Patch: ${x##*/}!"
317 eerror
318 eerror "Include in your bugreport the contents of:"
319 eerror
320 eerror " ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}"
321 echo
322 die "Failed Patch: ${x##*/}!"
323 fi
324
325 rm -f ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
326
327 eend 0
328 fi
329 done
330 if [ "${SINGLE_PATCH}" = "no" ]
331 then
332 einfo "Done with patching"
333 fi
334}
335
336# This function return true if we are using the NPTL pthreads
337# implementation.
338#
339# <azarah@gentoo.org> (06 March 2003)
340#
341
342have_NPTL() {
343
344 cat > ${T}/test-nptl.c <<-"END"
345 #define _XOPEN_SOURCE
346 #include <unistd.h>
347 #include <stdio.h>
348
349 int main()
350 {
351 char buf[255];
352 char *str = buf;
353
354 confstr(_CS_GNU_LIBPTHREAD_VERSION, str, 255);
355 if (NULL != str) {
356 printf("%s\n", str);
357 if (NULL != strstr(str, "NPTL"))
358 return 0;
359 }
360
361 return 1;
362 }
363 END
364
365 einfon "Checking for _CS_GNU_LIBPTHREAD_VERSION support in glibc ... "
366 if gcc -o ${T}/nptl ${T}/test-nptl.c &> /dev/null
367 then
368 echo "yes"
369 einfon "Checking what PTHREADS implementation we have ... "
370 if ${T}/nptl
371 then
372 return 0
373 else 596 else
374 return 1 597 TMPDIR="${topdir}" mktemp -dt tmp.XXXXXXXXXX
375 fi
376 else
377 echo "no"
378 fi
379
380 return 1
381}
382
383# This function check how many cpu's are present, and then set
384# -j in MAKEOPTS accordingly.
385#
386# Thanks to nall <nall@gentoo.org> for this.
387#
388get_number_of_jobs() {
389 local jobs=0
390
391 if [ ! -r /proc/cpuinfo ]
392 then
393 return 1
394 fi
395
396 # This bit is from H?kan Wessberg <nacka-gentoo@refug.org>, bug #13565.
397 if [ "`egrep "^[[:space:]]*MAKEOPTS=" /etc/make.conf | wc -l`" -gt 0 ]
398 then
399 ADMINOPTS="`egrep "^[[:space:]]*MAKEOPTS=" /etc/make.conf | cut -d= -f2 | sed 's/\"//g'`"
400 ADMINPARAM="`echo ${ADMINOPTS} | gawk '{match($0, /-j *[0-9]*/, opt); print opt[0]}'`"
401 ADMINPARAM="${ADMINPARAM/-j}"
402 fi
403
404 export MAKEOPTS="`echo ${MAKEOPTS} | sed -e 's:-j *[0-9]*::g'`"
405
406 if [ "${ARCH}" = "amd64" -o "${ARCH}" = "x86" -o "${ARCH}" = "hppa" -o \
407 "${ARCH}" = "arm" -o "${ARCH}" = "mips" -o "${ARCH}" = "ia64" ]
408 then
409 # these archs will always have "[Pp]rocessor"
410 jobs="$((`grep -c ^[Pp]rocessor /proc/cpuinfo` * 2))"
411
412 elif [ "${ARCH}" = "sparc" -o "${ARCH}" = "sparc64" ]
413 then
414 # sparc always has "ncpus active"
415 jobs="$((`grep "^ncpus active" /proc/cpuinfo | sed -e "s/^.*: //"` * 2))"
416
417 elif [ "${ARCH}" = "alpha" ]
418 then
419 # alpha has "cpus active", but only when compiled with SMP
420 if [ "`grep -c "^cpus active" /proc/cpuinfo`" -eq 1 ]
421 then
422 jobs="$((`grep "^cpus active" /proc/cpuinfo | sed -e "s/^.*: //"` * 2))"
423 else
424 jobs=2
425 fi
426
427 elif [ "${ARCH}" = "ppc" ]
428 then
429 # ppc has "processor", but only when compiled with SMP
430 if [ "`grep -c "^processor" /proc/cpuinfo`" -eq 1 ]
431 then
432 jobs="$((`grep -c ^processor /proc/cpuinfo` * 2))"
433 else
434 jobs=2
435 fi
436 else
437 jobs="$((`grep -c ^cpu /proc/cpuinfo` * 2))"
438 die "Unknown ARCH -- ${ARCH}!"
439 fi
440
441 # Make sure the number is valid ...
442 if [ "${jobs}" -lt 1 ]
443 then
444 jobs=1
445 fi
446
447 if [ -n "${ADMINPARAM}" ]
448 then
449 if [ "${jobs}" -gt "${ADMINPARAM}" ]
450 then
451 einfo "Setting make jobs to \"-j${ADMINPARAM}\" to ensure successful merge..."
452 export MAKEOPTS="${MAKEOPTS} -j${ADMINPARAM}"
453 else
454 einfo "Setting make jobs to \"-j${jobs}\" to ensure successful merge..."
455 export MAKEOPTS="${MAKEOPTS} -j${jobs}"
456 fi
457 fi
458}
459
460# Cheap replacement for when debianutils (and thus mktemp)
461# do not exist on the users system
462# vapier@gentoo.org
463#
464# Takes just 1 parameter (the directory to create tmpfile in)
465mymktemp() {
466 local topdir="$1"
467
468 [ -z "${topdir}" ] && topdir=/tmp
469 if [ "`which mktemp 2>/dev/null`" ]
470 then
471 mktemp -p ${topdir}
472 else
473 local tmp="${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM}"
474 touch ${tmp}
475 echo ${tmp}
476 fi
477}
478
479# Simplify/standardize adding users to the system
480# vapier@gentoo.org
481#
482# enewuser(username, uid, shell, homedir, groups, extra options)
483#
484# Default values if you do not specify any:
485# username: REQUIRED !
486# uid: next available (see useradd(8))
487# note: pass -1 to get default behavior
488# shell: /bin/false
489# homedir: /dev/null
490# groups: none
491# extra: comment of 'added by portage for ${PN}'
492enewuser() {
493 # get the username
494 local euser="$1"; shift
495 if [ -z "${euser}" ]
496 then
497 eerror "No username specified !"
498 die "Cannot call enewuser without a username"
499 fi
500
501 # setup a file for testing usernames/groups
502 local tmpfile="`mymktemp ${T}`"
503 chown ${euser} ${tmpfile} >& /dev/null
504 local realuser="`ls -l ${tmpfile} | awk '{print $3}'`"
505
506 # see if user already exists
507 if [ "${euser}" == "${realuser}" ]
508 then
509 return 0
510 fi
511 einfo "Adding user '${euser}' to your system ..."
512
513 # options to pass to useradd
514 local opts=
515
516 # handle uid
517 local euid="$1"; shift
518 if [ ! -z "${euid}" ] && [ "${euid}" != "-1" ]
519 then
520 if [ "${euid}" -gt 0 ]
521 then
522 opts="${opts} -u ${euid}"
523 else
524 eerror "Userid given but is not greater than 0 !"
525 die "${euid} is not a valid UID"
526 fi
527 else
528 euid="next available"
529 fi
530 einfo " - Userid: ${euid}"
531
532 # handle shell
533 local eshell="$1"; shift
534 if [ ! -z "${eshell}" ]
535 then
536 if [ ! -e "${eshell}" ]
537 then
538 eerror "A shell was specified but it does not exist !"
539 die "${eshell} does not exist"
540 fi
541 else
542 eshell="/bin/false"
543 fi
544 einfo " - Shell: ${eshell}"
545 opts="${opts} -s ${eshell}"
546
547 # handle homedir
548 local ehome="$1"; shift
549 if [ -z "${ehome}" ]
550 then
551 ehome="/dev/null"
552 fi
553 einfo " - Home: ${ehome}"
554 opts="${opts} -d ${ehome}"
555
556 # handle groups
557 local egroups="$1"; shift
558 if [ ! -z "${egroups}" ]
559 then
560 local realgroup=
561 local oldifs="${IFS}"
562 export IFS=","
563 for g in ${egroups}
564 do
565 chgrp ${g} ${tmpfile} >& /dev/null
566 realgroup="`ls -l ${tmpfile} | awk '{print $4}'`"
567 if [ "${g}" != "${realgroup}" ]
568 then
569 eerror "You must add ${g} to the system first"
570 die "${g} is not a valid GID"
571 fi 598 fi
572 done
573 export IFS="${oldifs}"
574 opts="${opts} -g ${egroups}"
575 else
576 egroups="(none)"
577 fi
578 einfo " - Groups: ${egroups}"
579
580 # handle extra and add the user
581 local eextra="$@"
582 local oldsandbox="${SANDBOX_ON}"
583 export SANDBOX_ON="0"
584 if [ -z "${eextra}" ]
585 then
586 useradd ${opts} ${euser} \
587 -c "added by portage for ${PN}" \
588 || die "enewuser failed"
589 else
590 einfo " - Extra: ${eextra}"
591 useradd ${opts} ${euser} ${eextra} \
592 || die "enewuser failed"
593 fi
594 export SANDBOX_ON="${oldsandbox}"
595
596 if [ ! -e "${ehome}" ] && [ ! -e "${D}/${ehome}" ]
597 then
598 einfo " - Creating ${ehome} in ${D}"
599 dodir ${ehome}
600 fowners ${euser} ${ehome}
601 fperms 755 ${ehome}
602 fi
603}
604
605# Simplify/standardize adding groups to the system
606# vapier@gentoo.org
607#
608# enewgroup(group, gid)
609#
610# Default values if you do not specify any:
611# groupname: REQUIRED !
612# gid: next available (see groupadd(8))
613# extra: none
614enewgroup() {
615 # get the group
616 local egroup="$1"; shift
617 if [ -z "${egroup}" ]
618 then
619 eerror "No group specified !"
620 die "Cannot call enewgroup without a group"
621 fi
622
623 # setup a file for testing groupname
624 local tmpfile="`mymktemp ${T}`"
625 chgrp ${egroup} ${tmpfile} >& /dev/null
626 local realgroup="`ls -l ${tmpfile} | awk '{print $4}'`"
627
628 # see if group already exists
629 if [ "${egroup}" == "${realgroup}" ]
630 then
631 return 0
632 fi
633 einfo "Adding group '${egroup}' to your system ..."
634
635 # options to pass to useradd
636 local opts=
637
638 # handle gid
639 local egid="$1"; shift
640 if [ ! -z "${egid}" ]
641 then
642 if [ "${egid}" -gt 0 ]
643 then
644 opts="${opts} -g ${egid}"
645 else
646 eerror "Groupid given but is not greater than 0 !"
647 die "${egid} is not a valid GID"
648 fi 599 fi
649 else
650 egid="next available"
651 fi
652 einfo " - Groupid: ${egid}"
653
654 # handle extra
655 local eextra="$@"
656 opts="${opts} ${eextra}"
657
658 # add the group
659 local oldsandbox="${SANDBOX_ON}"
660 export SANDBOX_ON="0"
661 groupadd ${opts} ${egroup} || die "enewgroup failed"
662 export SANDBOX_ON="${oldsandbox}"
663} 600}
664 601
665# Simple script to replace 'dos2unix' binaries 602# @FUNCTION: edos2unix
666# vapier@gentoo.org 603# @USAGE: <file> [more files ...]
667# 604# @DESCRIPTION:
668# edos2unix(file, <more files>...) 605# A handy replacement for dos2unix, recode, fixdos, etc... This allows you
606# to remove all of these text utilities from DEPEND variables because this
607# is a script based solution. Just give it a list of files to convert and
608# they will all be changed from the DOS CRLF format to the UNIX LF format.
669edos2unix() { 609edos2unix() {
670 for f in "$@" 610 [[ $# -eq 0 ]] && return 0
671 do 611 sed -i 's/\r$//' -- "$@" || die
672 cp "${f}" ${T}/edos2unix
673 sed 's/\r$//' ${T}/edos2unix > "${f}"
674 done
675} 612}
676 613
677# Make a desktop file ! 614# Make a desktop file !
678# Great for making those icons in kde/gnome startmenu ! 615# Great for making those icons in kde/gnome startmenu !
679# Amaze your friends ! Get the women ! Join today ! 616# Amaze your friends ! Get the women ! Join today !
680# gnome2 /usr/share/applications
681# gnome1 /usr/share/gnome/apps/
682# KDE ${KDEDIR}/share/applnk /usr/share/applnk
683# 617#
684# make_desktop_entry(<binary>, [name], [icon], [type], [path]) 618# make_desktop_entry(<command>, [name], [icon], [type], [fields])
685# 619#
686# binary: what binary does the app run with ? 620# binary: what command does the app run with ?
687# name: the name that will show up in the menu 621# name: the name that will show up in the menu
688# icon: give your little like a pretty little icon ... 622# icon: give your little like a pretty little icon ...
689# this can be relative (to /usr/share/pixmaps) or 623# this can be relative (to /usr/share/pixmaps) or
690# a full path to an icon 624# a full path to an icon
691# type: what kind of application is this ? for categories: 625# type: what kind of application is this ? for categories:
692# http://www.freedesktop.org/standards/menu/draft/menu-spec/menu-spec.html 626# http://standards.freedesktop.org/menu-spec/latest/apa.html
693# path: if your app needs to startup in a specific dir 627# fields: extra fields to append to the desktop file; a printf string
694make_desktop_entry() { 628make_desktop_entry() {
695 [ -z "$1" ] && eerror "You must specify the executable" && return 1 629 [[ -z $1 ]] && die "make_desktop_entry: You must specify the executable"
696 630
697 local exec="${1}" 631 local exec=${1}
698 local name="${2:-${PN}}" 632 local name=${2:-${PN}}
699 local icon="${3:-${PN}.png}" 633 local icon=${3:-${PN}}
700 local type="${4}" 634 local type=${4}
701 local path="${5:-${GAMES_PREFIX}}" 635 local fields=${5}
636
702 if [ -z "${type}" ] 637 if [[ -z ${type} ]] ; then
703 then 638 local catmaj=${CATEGORY%%-*}
704 case ${CATEGORY} in 639 local catmin=${CATEGORY##*-}
705 "app-emulation") 640 case ${catmaj} in
706 type=Emulator 641 app)
642 case ${catmin} in
643 accessibility) type=Accessibility;;
644 admin) type=System;;
645 antivirus) type=System;;
646 arch) type=Archiving;;
647 backup) type=Archiving;;
648 cdr) type=DiscBurning;;
649 dicts) type=Dictionary;;
650 doc) type=Documentation;;
651 editors) type=TextEditor;;
652 emacs) type=TextEditor;;
653 emulation) type=Emulator;;
654 laptop) type=HardwareSettings;;
655 office) type=Office;;
656 pda) type=PDA;;
657 vim) type=TextEditor;;
658 xemacs) type=TextEditor;;
659 esac
660 ;;
661
662 dev)
663 type="Development"
664 ;;
665
666 games)
667 case ${catmin} in
668 action|fps) type=ActionGame;;
669 arcade) type=ArcadeGame;;
670 board) type=BoardGame;;
671 emulation) type=Emulator;;
672 kids) type=KidsGame;;
673 puzzle) type=LogicGame;;
674 roguelike) type=RolePlaying;;
675 rpg) type=RolePlaying;;
676 simulation) type=Simulation;;
677 sports) type=SportsGame;;
678 strategy) type=StrategyGame;;
679 esac
680 type="Game;${type}"
681 ;;
682
683 gnome)
684 type="Gnome;GTK"
685 ;;
686
687 kde)
688 type="KDE;Qt"
689 ;;
690
691 mail)
692 type="Network;Email"
693 ;;
694
695 media)
696 case ${catmin} in
697 gfx)
698 type=Graphics
707 ;; 699 ;;
708 "games-"*) 700 *)
709 type=Game 701 case ${catmin} in
702 radio) type=Tuner;;
703 sound) type=Audio;;
704 tv) type=TV;;
705 video) type=Video;;
706 esac
707 type="AudioVideo;${type}"
710 ;; 708 ;;
709 esac
710 ;;
711
712 net)
713 case ${catmin} in
714 dialup) type=Dialup;;
715 ftp) type=FileTransfer;;
716 im) type=InstantMessaging;;
717 irc) type=IRCClient;;
718 mail) type=Email;;
719 news) type=News;;
720 nntp) type=News;;
721 p2p) type=FileTransfer;;
722 voip) type=Telephony;;
723 esac
724 type="Network;${type}"
725 ;;
726
727 sci)
728 case ${catmin} in
729 astro*) type=Astronomy;;
730 bio*) type=Biology;;
731 calc*) type=Calculator;;
732 chem*) type=Chemistry;;
733 elec*) type=Electronics;;
734 geo*) type=Geology;;
735 math*) type=Math;;
736 physics) type=Physics;;
737 visual*) type=DataVisualization;;
738 esac
739 type="Education;Science;${type}"
740 ;;
741
742 sys)
743 type="System"
744 ;;
745
746 www)
747 case ${catmin} in
748 client) type=WebBrowser;;
749 esac
750 type="Network;${type}"
751 ;;
752
711 *) 753 *)
712 type= 754 type=
713 ;; 755 ;;
714 esac 756 esac
715 fi 757 fi
716 local desktop="${T}/${exec}.desktop" 758 if [ "${SLOT}" == "0" ] ; then
759 local desktop_name="${PN}"
760 else
761 local desktop_name="${PN}-${SLOT}"
762 fi
763 local desktop="${T}/$(echo ${exec} | sed 's:[[:space:]/:]:_:g')-${desktop_name}.desktop"
764 #local desktop=${T}/${exec%% *:-${desktop_name}}.desktop
717 765
766 # Don't append another ";" when a valid category value is provided.
767 type=${type%;}${type:+;}
768
769 eshopts_push -s extglob
770 if [[ -n ${icon} && ${icon} != /* ]] && [[ ${icon} == *.xpm || ${icon} == *.png || ${icon} == *.svg ]]; then
771 ewarn "As described in the Icon Theme Specification, icon file extensions are not"
772 ewarn "allowed in .desktop files if the value is not an absolute path."
773 icon=${icon%.@(xpm|png|svg)}
774 fi
775 eshopts_pop
776
777 cat <<-EOF > "${desktop}"
718echo "[Desktop Entry] 778 [Desktop Entry]
719Encoding=UTF-8
720Version=0.9.2
721Name=${name} 779 Name=${name}
722Type=Application 780 Type=Application
723Comment=${DESCRIPTION} 781 Comment=${DESCRIPTION}
724Exec=${exec} 782 Exec=${exec}
725Path=${path} 783 TryExec=${exec%% *}
726Icon=${icon} 784 Icon=${icon}
727Categories=Application;${type};" > ${desktop} 785 Categories=${type}
786 EOF
728 787
729 if [ -d "/usr/share/applications" ] 788 if [[ ${fields:-=} != *=* ]] ; then
730 then 789 # 5th arg used to be value to Path=
790 ewarn "make_desktop_entry: update your 5th arg to read Path=${fields}"
791 fields="Path=${fields}"
792 fi
793 [[ -n ${fields} ]] && printf '%b\n' "${fields}" >> "${desktop}"
794
795 (
796 # wrap the env here so that the 'insinto' call
797 # doesn't corrupt the env of the caller
731 insinto /usr/share/applications 798 insinto /usr/share/applications
732 doins ${desktop} 799 doins "${desktop}"
733 fi 800 ) || die "installing desktop file failed"
801}
734 802
735 #if [ -d "/usr/share/gnome/apps" ] 803# @FUNCTION: validate_desktop_entries
736 #then 804# @USAGE: [directories]
737 # insinto /usr/share/gnome/apps/Games 805# @MAINTAINER:
738 # doins ${desktop} 806# Carsten Lohrke <carlo@gentoo.org>
739 #fi 807# @DESCRIPTION:
740 808# Validate desktop entries using desktop-file-utils
741 #if [ ! -z "`ls /usr/kde/* 2>/dev/null`" ] 809validate_desktop_entries() {
742 #then 810 if [[ -x /usr/bin/desktop-file-validate ]] ; then
743 # for ver in /usr/kde/* 811 einfo "Checking desktop entry validity"
744 # do 812 local directories=""
745 # insinto ${ver}/share/applnk/Games 813 for d in /usr/share/applications $@ ; do
746 # doins ${desktop} 814 [[ -d ${D}${d} ]] && directories="${directories} ${D}${d}"
747 # done 815 done
748 #fi 816 if [[ -n ${directories} ]] ; then
749 817 for FILE in $(find ${directories} -name "*\.desktop" \
750 if [ -d "/usr/share/applnk" ] 818 -not -path '*.hidden*' | sort -u 2>/dev/null)
751 then
752 insinto /usr/share/applnk/${type}
753 doins ${desktop}
754 fi
755
756 return 0
757}
758
759# new convenience patch wrapper function to eventually replace epatch(),
760# $PATCHES, $PATCHES1, src_unpack:patch, src_unpack:autopatch and
761# /usr/bin/patch
762# Features:
763# - bulk patch handling similar to epatch()'s
764# - automatic patch level detection like epatch()'s
765# - automatic patch uncompression like epatch()'s
766# - doesn't have the --dry-run overhead of epatch() - inspects patchfiles
767# manually instead
768# - once I decide it's production-ready, it'll be called from base_src_unpack
769# to handle $PATCHES to avoid defining src_unpack just to use xpatch
770
771# accepts zero or more parameters specifying patchfiles and/or patchdirs
772
773# known issues:
774# - only supports unified style patches (does anyone _really_ use anything
775# else?)
776# - because it doesn't use --dry-run there is a risk of it failing
777# to find the files to patch, ie detect the patchlevel, properly. It doesn't use
778# any of the backup heuristics that patch employs to discover a filename.
779# however, this isn't dangerous because if it works for the developer who's
780# writing the ebuild, it'll always work for the users, and if it doesn't,
781# then we'll fix it :-)
782# - no support as yet for patches applying outside $S (and not directly in $WORKDIR).
783xpatch() {
784
785 debug-print-function ${FUNCNAME} $*
786
787 local list=
788 local list2=
789 declare -i plevel
790
791 # parse patch sources
792 for x in $*
793 do
794 debug-print "${FUNCNAME}: parsing parameter ${x}"
795 if [ -f "${x}" ]
796 then
797 list="${list} ${x}"
798 elif [ -d "${x}" ]
799 then
800 # handles patchdirs like epatch() for now: no recursion.
801 # patches are sorted by filename, so with an xy_foo naming scheme you'll get the right order.
802 # only patches with _$ARCH_ or _all_ in their filenames are applied.
803 for file in `ls -A ${x}`
804 do 819 do
805 debug-print "${FUNCNAME}: parsing in subdir: file ${file}" 820 local temp=$(desktop-file-validate ${FILE} | grep -v "warning:" | \
806 if [ -f "${x}/${file}" -a "${file}" != "${file/_all_}" -o \ 821 sed -e "s|error: ||" -e "s|${FILE}:|--|g" )
807 "${file}" != "${file/_$ARCH_}" ] 822 [[ -n $temp ]] && elog ${temp/--/${FILE/${D}/}:}
808 then
809 list2="${list2} ${x}/${file}"
810 fi
811 done 823 done
812 list="`echo ${list2} | sort` ${list}" 824 fi
825 echo ""
826 else
827 einfo "Passing desktop entry validity check. Install dev-util/desktop-file-utils, if you want to help to improve Gentoo."
828 fi
829}
830
831# @FUNCTION: make_session_desktop
832# @USAGE: <title> <command> [command args...]
833# @DESCRIPTION:
834# Make a GDM/KDM Session file. The title is the file to execute to start the
835# Window Manager. The command is the name of the Window Manager.
836#
837# You can set the name of the file via the ${wm} variable.
838make_session_desktop() {
839 [[ -z $1 ]] && eerror "$0: You must specify the title" && return 1
840 [[ -z $2 ]] && eerror "$0: You must specify the command" && return 1
841
842 local title=$1
843 local command=$2
844 local desktop=${T}/${wm:-${PN}}.desktop
845 shift 2
846
847 cat <<-EOF > "${desktop}"
848 [Desktop Entry]
849 Name=${title}
850 Comment=This session logs you into ${title}
851 Exec=${command} $*
852 TryExec=${command}
853 Type=XSession
854 EOF
855
856 (
857 # wrap the env here so that the 'insinto' call
858 # doesn't corrupt the env of the caller
859 insinto /usr/share/xsessions
860 doins "${desktop}"
861 )
862}
863
864# @FUNCTION: domenu
865# @USAGE: <menus>
866# @DESCRIPTION:
867# Install the list of .desktop menu files into the appropriate directory
868# (/usr/share/applications).
869domenu() {
870 (
871 # wrap the env here so that the 'insinto' call
872 # doesn't corrupt the env of the caller
873 local i j ret=0
874 insinto /usr/share/applications
875 for i in "$@" ; do
876 if [[ -f ${i} ]] ; then
877 doins "${i}"
878 ((ret+=$?))
879 elif [[ -d ${i} ]] ; then
880 for j in "${i}"/*.desktop ; do
881 doins "${j}"
882 ((ret+=$?))
883 done
813 else 884 else
814 die "Couldn't find ${x}" 885 ((++ret))
815 fi 886 fi
816 done 887 done
888 exit ${ret}
889 )
890}
817 891
818 debug-print "${FUNCNAME}: final list of patches: ${list}" 892# @FUNCTION: newmenu
893# @USAGE: <menu> <newname>
894# @DESCRIPTION:
895# Like all other new* functions, install the specified menu as newname.
896newmenu() {
897 (
898 # wrap the env here so that the 'insinto' call
899 # doesn't corrupt the env of the caller
900 insinto /usr/share/applications
901 newins "$@"
902 )
903}
819 904
820 for x in ${list}; 905# @FUNCTION: doicon
821 do 906# @USAGE: <list of icons>
822 debug-print "${FUNCNAME}: processing ${x}" 907# @DESCRIPTION:
823 # deal with compressed files. /usr/bin/file is in the system profile, or should be. 908# Install the list of icons into the icon directory (/usr/share/pixmaps).
824 case "`/usr/bin/file -b ${x}`" in 909# This is useful in conjunction with creating desktop/menu files.
825 *gzip*) 910doicon() {
826 patchfile="${T}/current.patch" 911 (
827 ungzip -c "${x}" > "${patchfile}" 912 # wrap the env here so that the 'insinto' call
828 ;; 913 # doesn't corrupt the env of the caller
829 *bzip2*) 914 local i j ret
830 patchfile="${T}/current.patch" 915 insinto /usr/share/pixmaps
831 bunzip2 -c "${x}" > "${patchfile}" 916 for i in "$@" ; do
832 ;; 917 if [[ -f ${i} ]] ; then
833 *text*) 918 doins "${i}"
834 patchfile="${x}" 919 ((ret+=$?))
835 ;; 920 elif [[ -d ${i} ]] ; then
836 *) 921 for j in "${i}"/*.png ; do
837 die "Could not determine filetype of patch ${x}" 922 doins "${j}"
838 ;; 923 ((ret+=$?))
839 esac
840 debug-print "${FUNCNAME}: patchfile=${patchfile}"
841
842 # determine patchlevel. supports p0 and higher with either $S or $WORKDIR as base.
843 target="`/bin/grep -m 1 '^+++ ' ${patchfile}`"
844 debug-print "${FUNCNAME}: raw target=${target}"
845 # strip target down to the path/filename, remove leading +++
846 target="${target/+++ }"; target="${target%% *}"
847 # duplicate slashes are discarded by patch wrt the patchlevel. therefore we need
848 # to discard them as well to calculate the correct patchlevel.
849 target="${target//\/\//\/}"
850 debug-print "${FUNCNAME}: stripped target=${target}"
851
852 # look for target
853 for basedir in "${S}" "${WORKDIR}" "${PWD}"; do
854 debug-print "${FUNCNAME}: looking in basedir=${basedir}"
855 cd "${basedir}"
856
857 # try stripping leading directories
858 target2="${target}"
859 plevel=0
860 debug-print "${FUNCNAME}: trying target2=${target2}, plevel=${plevel}"
861 while [ ! -f "${target2}" ]
862 do
863 target2="${target2#*/}" # removes piece of target2 upto the first occurence of /
864 plevel=$((plevel+1))
865 debug-print "${FUNCNAME}: trying target2=${target2}, plevel=${plevel}"
866 [ "${target2}" == "${target2/\/}" ] && break
867 done 924 done
868 test -f "${target2}" && break 925 else
869 926 ((++ret))
870 # try stripping filename - needed to support patches creating new files 927 fi
871 target2="${target%/*}"
872 plevel=0
873 debug-print "${FUNCNAME}: trying target2=${target2}, plevel=${plevel}"
874 while [ ! -d "${target2}" ]
875 do
876 target2="${target2#*/}" # removes piece of target2 upto the first occurence of /
877 plevel=$((plevel+1))
878 debug-print "${FUNCNAME}: trying target2=${target2}, plevel=${plevel}"
879 [ "${target2}" == "${target2/\/}" ] && break
880 done
881 test -d "${target2}" && break
882
883 done
884
885 test -f "${basedir}/${target2}" || test -d "${basedir}/${target2}" \
886 || die "Could not determine patchlevel for ${x}"
887 debug-print "${FUNCNAME}: determined plevel=${plevel}"
888 # do the patching
889 ebegin "Applying patch ${x##*/}..."
890 /usr/bin/patch -p${plevel} < "${patchfile}" > /dev/null \
891 || die "Failed to apply patch ${x}"
892 eend $?
893
894 done 928 done
895 929 exit ${ret}
930 )
896} 931}
897 932
933# @FUNCTION: newicon
934# @USAGE: <icon> <newname>
935# @DESCRIPTION:
936# Like all other new* functions, install the specified icon as newname.
937newicon() {
938 (
939 # wrap the env here so that the 'insinto' call
940 # doesn't corrupt the env of the caller
941 insinto /usr/share/pixmaps
942 newins "$@"
943 )
944}
945
946# for internal use only (unpack_pdv and unpack_makeself)
947find_unpackable_file() {
948 local src=$1
949 if [[ -z ${src} ]] ; then
950 src=${DISTDIR}/${A}
951 else
952 if [[ -e ${DISTDIR}/${src} ]] ; then
953 src=${DISTDIR}/${src}
954 elif [[ -e ${PWD}/${src} ]] ; then
955 src=${PWD}/${src}
956 elif [[ -e ${src} ]] ; then
957 src=${src}
958 fi
959 fi
960 [[ ! -e ${src} ]] && return 1
961 echo "${src}"
962}
963
964# @FUNCTION: unpack_pdv
965# @USAGE: <file to unpack> <size of off_t>
966# @DESCRIPTION:
967# Unpack those pesky pdv generated files ...
968# They're self-unpacking programs with the binary package stuffed in
969# the middle of the archive. Valve seems to use it a lot ... too bad
970# it seems to like to segfault a lot :(. So lets take it apart ourselves.
971#
972# You have to specify the off_t size ... I have no idea how to extract that
973# information out of the binary executable myself. Basically you pass in
974# the size of the off_t type (in bytes) on the machine that built the pdv
975# archive.
976#
977# One way to determine this is by running the following commands:
978#
979# @CODE
980# strings <pdv archive> | grep lseek
981# strace -elseek <pdv archive>
982# @CODE
983#
984# Basically look for the first lseek command (we do the strings/grep because
985# sometimes the function call is _llseek or something) and steal the 2nd
986# parameter. Here is an example:
987#
988# @CODE
989# vapier@vapier 0 pdv_unpack # strings hldsupdatetool.bin | grep lseek
990# lseek
991# vapier@vapier 0 pdv_unpack # strace -elseek ./hldsupdatetool.bin
992# lseek(3, -4, SEEK_END) = 2981250
993# @CODE
994#
995# Thus we would pass in the value of '4' as the second parameter.
996unpack_pdv() {
997 local src=$(find_unpackable_file "$1")
998 local sizeoff_t=$2
999
1000 [[ -z ${src} ]] && die "Could not locate source for '$1'"
1001 [[ -z ${sizeoff_t} ]] && die "No idea what off_t size was used for this pdv :("
1002
1003 local shrtsrc=$(basename "${src}")
1004 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1005 local metaskip=$(tail -c ${sizeoff_t} "${src}" | hexdump -e \"%i\")
1006 local tailskip=$(tail -c $((${sizeoff_t}*2)) "${src}" | head -c ${sizeoff_t} | hexdump -e \"%i\")
1007
1008 # grab metadata for debug reasons
1009 local metafile=$(emktemp)
1010 tail -c +$((${metaskip}+1)) "${src}" > "${metafile}"
1011
1012 # rip out the final file name from the metadata
1013 local datafile=$(tail -c +$((${metaskip}+1)) "${src}" | strings | head -n 1)
1014 datafile=$(basename "${datafile}")
1015
1016 # now lets uncompress/untar the file if need be
1017 local tmpfile=$(emktemp)
1018 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null | head -c 512 > ${tmpfile}
1019
1020 local iscompressed=$(file -b "${tmpfile}")
1021 if [[ ${iscompressed:0:8} == "compress" ]] ; then
1022 iscompressed=1
1023 mv ${tmpfile}{,.Z}
1024 gunzip ${tmpfile}
1025 else
1026 iscompressed=0
1027 fi
1028 local istar=$(file -b "${tmpfile}")
1029 if [[ ${istar:0:9} == "POSIX tar" ]] ; then
1030 istar=1
1031 else
1032 istar=0
1033 fi
1034
1035 #for some reason gzip dies with this ... dd cant provide buffer fast enough ?
1036 #dd if=${src} ibs=${metaskip} count=1 \
1037 # | dd ibs=${tailskip} skip=1 \
1038 # | gzip -dc \
1039 # > ${datafile}
1040 if [ ${iscompressed} -eq 1 ] ; then
1041 if [ ${istar} -eq 1 ] ; then
1042 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1043 | head -c $((${metaskip}-${tailskip})) \
1044 | tar -xzf -
1045 else
1046 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1047 | head -c $((${metaskip}-${tailskip})) \
1048 | gzip -dc \
1049 > ${datafile}
1050 fi
1051 else
1052 if [ ${istar} -eq 1 ] ; then
1053 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1054 | head -c $((${metaskip}-${tailskip})) \
1055 | tar --no-same-owner -xf -
1056 else
1057 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1058 | head -c $((${metaskip}-${tailskip})) \
1059 > ${datafile}
1060 fi
1061 fi
1062 true
1063 #[ -s "${datafile}" ] || die "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')"
1064 #assert "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')"
1065}
1066
1067# @FUNCTION: unpack_makeself
1068# @USAGE: [file to unpack] [offset] [tail|dd]
1069# @DESCRIPTION:
898# Unpack those pesky makeself generated files ... 1070# Unpack those pesky makeself generated files ...
899# They're shell scripts with the binary package tagged onto 1071# They're shell scripts with the binary package tagged onto
900# the end of the archive. Loki utilized the format as does 1072# the end of the archive. Loki utilized the format as does
901# many other game companies. 1073# many other game companies.
902# 1074#
903# Usage: unpack_makeself [file to unpack] [offset] 1075# If the file is not specified, then ${A} is used. If the
904# - If the file is not specified then unpack will utilize ${A}.
905# - If the offset is not specified then we will attempt to extract 1076# offset is not specified then we will attempt to extract
906# the proper offset from the script itself. 1077# the proper offset from the script itself.
907unpack_makeself() { 1078unpack_makeself() {
908 local src="$1" 1079 local src_input=${1:-${A}}
1080 local src=$(find_unpackable_file "${src_input}")
909 local skip="$2" 1081 local skip=$2
1082 local exe=$3
910 1083
911 if [ -z "${src}" ] 1084 [[ -z ${src} ]] && die "Could not locate source for '${src_input}'"
912 then
913 src="${DISTDIR}/${A}"
914 else
915 if [ -e "${DISTDIR}/${src}" ]
916 then
917 src="${DISTDIR}/${src}"
918 elif [ -e "${PWD}/${src}" ]
919 then
920 src="${PWD}/${src}"
921 elif [ -e "${src}" ]
922 then
923 src="${src}"
924 fi
925 fi
926 [ ! -e "${src}" ] && die "Could not find requested makeself archive ${src}"
927 1085
928 local shrtsrc="`basename ${src}`" 1086 local shrtsrc=$(basename "${src}")
929 echo ">>> Unpacking ${shrtsrc} to ${PWD}" 1087 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
930 if [ -z "${skip}" ] 1088 if [[ -z ${skip} ]] ; then
931 then
932 local ver="`grep -a '#.*Makeself' ${src} | awk '{print $NF}'`" 1089 local ver=$(grep -m1 -a '#.*Makeself' "${src}" | awk '{print $NF}')
933 local skip=0 1090 local skip=0
1091 exe=tail
934 case ${ver} in 1092 case ${ver} in
935 1.5.*) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same 1093 1.5.*|1.6.0-nv) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same
936 skip=`grep -a ^skip= ${src} | cut -d= -f2` 1094 skip=$(grep -a ^skip= "${src}" | cut -d= -f2)
937 ;; 1095 ;;
938 2.0|2.0.1) 1096 2.0|2.0.1)
939 skip=`grep -a ^$'\t'tail ${src} | awk '{print $2}' | cut -b2-` 1097 skip=$(grep -a ^$'\t'tail "${src}" | awk '{print $2}' | cut -b2-)
940 ;; 1098 ;;
941 2.1.1) 1099 2.1.1)
942 skip=`grep -a ^offset= ${src} | awk '{print $2}' | cut -b2-` 1100 skip=$(grep -a ^offset= "${src}" | awk '{print $2}' | cut -b2-)
943 let skip="skip + 1" 1101 (( skip++ ))
944 ;; 1102 ;;
945 2.1.2) 1103 2.1.2)
946 skip=`grep -a ^offset= ${src} | awk '{print $3}' | head -n 1` 1104 skip=$(grep -a ^offset= "${src}" | awk '{print $3}' | head -n 1)
947 let skip="skip + 1" 1105 (( skip++ ))
948 ;; 1106 ;;
949 2.1.3) 1107 2.1.3)
950 skip=`grep -a ^offset= ${src} | awk '{print $3}'` 1108 skip=`grep -a ^offset= "${src}" | awk '{print $3}'`
951 let skip="skip + 1" 1109 (( skip++ ))
1110 ;;
1111 2.1.4|2.1.5)
1112 skip=$(grep -a offset=.*head.*wc "${src}" | awk '{print $3}' | head -n 1)
1113 skip=$(head -n ${skip} "${src}" | wc -c)
1114 exe="dd"
952 ;; 1115 ;;
953 *) 1116 *)
954 eerror "I'm sorry, but I was unable to support the Makeself file." 1117 eerror "I'm sorry, but I was unable to support the Makeself file."
955 eerror "The version I detected was '${ver}'." 1118 eerror "The version I detected was '${ver}'."
956 eerror "Please file a bug about the file ${shrtsrc} at" 1119 eerror "Please file a bug about the file ${shrtsrc} at"
958 die "makeself version '${ver}' not supported" 1121 die "makeself version '${ver}' not supported"
959 ;; 1122 ;;
960 esac 1123 esac
961 debug-print "Detected Makeself version ${ver} ... using ${skip} as offset" 1124 debug-print "Detected Makeself version ${ver} ... using ${skip} as offset"
962 fi 1125 fi
963
964 # we do this because otherwise a failure in gzip will cause 0 bytes to be sent
965 # to tar which will make tar not extract anything and exit with 0
966 tail -n +${skip} ${src} 2>/dev/null \
967 | gzip -cd 2>/dev/null \
968 | tar -x --no-same-owner -f - 2>/dev/null
969 local pipestatus="${PIPESTATUS[*]}"
970 pipestatus="${pipestatus// }"
971 if [ "${pipestatus//0}" != "" ]
972 then
973 # maybe it isnt gzipped ... they usually are, but not always ...
974 tail -n +${skip} ${src} | tar -x --no-same-owner -f - \
975 || die "failure unpacking makeself ${shrtsrc} ('${ver}' +${skip})"
976 fi
977}
978
979# Display a license for user to accept.
980#
981# Usage: check_license [license]
982# - If the file is not specified then ${LICENSE} is used.
983check_license() {
984 local lic=$1
985 if [ -z "${lic}" ] ; then
986 lic="${PORTDIR}/licenses/${LICENSE}"
987 else
988 if [ -e "${PORTDIR}/licenses/${src}" ] ; then
989 lic="${PORTDIR}/licenses/${src}"
990 elif [ -e "${PWD}/${src}" ] ; then
991 lic="${PWD}/${src}"
992 elif [ -e "${src}" ] ; then
993 lic="${src}"
994 fi
995 fi
996 [ ! -f "${lic}" ] && die "Could not find requested license ${src}"
997
998 # here is where we check for the licenses the user already
999 # accepted ... if we don't find a match, we make the user accept
1000 local alic
1001 for alic in ${ACCEPT_LICENSE} ; do
1002 [ "${alic}" == "*" ] && return 0
1003 [ "${alic}" == "${lic}" ] && return 0
1004 done
1005
1006 local licmsg="`mymktemp ${T}`"
1007 cat << EOF > ${licmsg}
1008**********************************************************
1009The following license outlines the terms of use of this
1010package. You MUST accept this license for installation to
1011continue. When you are done viewing, hit 'q'. If you
1012CTRL+C out of this, the install will not run!
1013**********************************************************
1014
1015EOF
1016 cat ${lic} >> ${licmsg}
1017 ${PAGER:-less} ${licmsg} || die "Could not execute pager (${PAGER}) to accept ${lic}"
1018 einfon "Do you accept the terms of this license? [yes/no] "
1019 read alic
1020 case ${alic} in 1126 case ${exe} in
1021 yes|Yes|y|Y) 1127 tail) exe="tail -n +${skip} '${src}'";;
1022 return 0 1128 dd) exe="dd ibs=${skip} skip=1 if='${src}'";;
1129 *) die "makeself cant handle exe '${exe}'"
1130 esac
1131
1132 # lets grab the first few bytes of the file to figure out what kind of archive it is
1133 local filetype tmpfile=$(emktemp)
1134 eval ${exe} 2>/dev/null | head -c 512 > "${tmpfile}"
1135 filetype=$(file -b "${tmpfile}") || die
1136 case ${filetype} in
1137 *tar\ archive*)
1138 eval ${exe} | tar --no-same-owner -xf -
1139 ;;
1140 bzip2*)
1141 eval ${exe} | bzip2 -dc | tar --no-same-owner -xf -
1142 ;;
1143 gzip*)
1144 eval ${exe} | tar --no-same-owner -xzf -
1145 ;;
1146 compress*)
1147 eval ${exe} | gunzip | tar --no-same-owner -xf -
1023 ;; 1148 ;;
1024 *) 1149 *)
1025 echo;echo;echo 1150 eerror "Unknown filetype \"${filetype}\" ?"
1026 eerror "You MUST accept the license to continue! Exiting!" 1151 false
1027 die "Failed to accept license"
1028 ;; 1152 ;;
1029 esac 1153 esac
1154 assert "failure unpacking (${filetype}) makeself ${shrtsrc} ('${ver}' +${skip})"
1030} 1155}
1156
1157# @FUNCTION: cdrom_get_cds
1158# @USAGE: <file on cd1> [file on cd2] [file on cd3] [...]
1159# @DESCRIPTION:
1160# Aquire cd(s) for those lovely cd-based emerges. Yes, this violates
1161# the whole 'non-interactive' policy, but damnit I want CD support !
1162#
1163# With these cdrom functions we handle all the user interaction and
1164# standardize everything. All you have to do is call cdrom_get_cds()
1165# and when the function returns, you can assume that the cd has been
1166# found at CDROM_ROOT.
1167#
1168# The function will attempt to locate a cd based upon a file that is on
1169# the cd. The more files you give this function, the more cds
1170# the cdrom functions will handle.
1171#
1172# Normally the cdrom functions will refer to the cds as 'cd #1', 'cd #2',
1173# etc... If you want to give the cds better names, then just export
1174# the appropriate CDROM_NAME variable before calling cdrom_get_cds().
1175# Use CDROM_NAME for one cd, or CDROM_NAME_# for multiple cds. You can
1176# also use the CDROM_NAME_SET bash array.
1177#
1178# For those multi cd ebuilds, see the cdrom_load_next_cd() function.
1179cdrom_get_cds() {
1180 # first we figure out how many cds we're dealing with by
1181 # the # of files they gave us
1182 local cdcnt=0
1183 local f=
1184 for f in "$@" ; do
1185 ((++cdcnt))
1186 export CDROM_CHECK_${cdcnt}="$f"
1187 done
1188 export CDROM_TOTAL_CDS=${cdcnt}
1189 export CDROM_CURRENT_CD=1
1190
1191 # now we see if the user gave use CD_ROOT ...
1192 # if they did, let's just believe them that it's correct
1193 if [[ -n ${CD_ROOT}${CD_ROOT_1} ]] ; then
1194 local var=
1195 cdcnt=0
1196 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1197 ((++cdcnt))
1198 var="CD_ROOT_${cdcnt}"
1199 [[ -z ${!var} ]] && var="CD_ROOT"
1200 if [[ -z ${!var} ]] ; then
1201 eerror "You must either use just the CD_ROOT"
1202 eerror "or specify ALL the CD_ROOT_X variables."
1203 eerror "In this case, you will need ${CDROM_TOTAL_CDS} CD_ROOT_X variables."
1204 die "could not locate CD_ROOT_${cdcnt}"
1205 fi
1206 done
1207 export CDROM_ROOT=${CD_ROOT_1:-${CD_ROOT}}
1208 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1209 export CDROM_SET=-1
1210 for f in ${CDROM_CHECK_1//:/ } ; do
1211 ((++CDROM_SET))
1212 [[ -e ${CDROM_ROOT}/${f} ]] && break
1213 done
1214 export CDROM_MATCH=${f}
1215 return
1216 fi
1217
1218 # User didn't help us out so lets make sure they know they can
1219 # simplify the whole process ...
1220 if [[ ${CDROM_TOTAL_CDS} -eq 1 ]] ; then
1221 einfo "This ebuild will need the ${CDROM_NAME:-cdrom for ${PN}}"
1222 echo
1223 einfo "If you do not have the CD, but have the data files"
1224 einfo "mounted somewhere on your filesystem, just export"
1225 einfo "the variable CD_ROOT so that it points to the"
1226 einfo "directory containing the files."
1227 echo
1228 einfo "For example:"
1229 einfo "export CD_ROOT=/mnt/cdrom"
1230 echo
1231 else
1232 if [[ -n ${CDROM_NAME_SET} ]] ; then
1233 # Translate the CDROM_NAME_SET array into CDROM_NAME_#
1234 cdcnt=0
1235 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1236 ((++cdcnt))
1237 export CDROM_NAME_${cdcnt}="${CDROM_NAME_SET[$((${cdcnt}-1))]}"
1238 done
1239 fi
1240
1241 einfo "This package will need access to ${CDROM_TOTAL_CDS} cds."
1242 cdcnt=0
1243 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1244 ((++cdcnt))
1245 var="CDROM_NAME_${cdcnt}"
1246 [[ ! -z ${!var} ]] && einfo " CD ${cdcnt}: ${!var}"
1247 done
1248 echo
1249 einfo "If you do not have the CDs, but have the data files"
1250 einfo "mounted somewhere on your filesystem, just export"
1251 einfo "the following variables so they point to the right place:"
1252 einfon ""
1253 cdcnt=0
1254 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1255 ((++cdcnt))
1256 echo -n " CD_ROOT_${cdcnt}"
1257 done
1258 echo
1259 einfo "Or, if you have all the files in the same place, or"
1260 einfo "you only have one cdrom, you can export CD_ROOT"
1261 einfo "and that place will be used as the same data source"
1262 einfo "for all the CDs."
1263 echo
1264 einfo "For example:"
1265 einfo "export CD_ROOT_1=/mnt/cdrom"
1266 echo
1267 fi
1268
1269 export CDROM_SET=""
1270 export CDROM_CURRENT_CD=0
1271 cdrom_load_next_cd
1272}
1273
1274# @FUNCTION: cdrom_load_next_cd
1275# @DESCRIPTION:
1276# Some packages are so big they come on multiple CDs. When you're done reading
1277# files off a CD and want access to the next one, just call this function.
1278# Again, all the messy details of user interaction are taken care of for you.
1279# Once this returns, just read the variable CDROM_ROOT for the location of the
1280# mounted CD. Note that you can only go forward in the CD list, so make sure
1281# you only call this function when you're done using the current CD.
1282cdrom_load_next_cd() {
1283 local var
1284 ((++CDROM_CURRENT_CD))
1285
1286 unset CDROM_ROOT
1287 var=CD_ROOT_${CDROM_CURRENT_CD}
1288 [[ -z ${!var} ]] && var="CD_ROOT"
1289 if [[ -z ${!var} ]] ; then
1290 var="CDROM_CHECK_${CDROM_CURRENT_CD}"
1291 _cdrom_locate_file_on_cd ${!var}
1292 else
1293 export CDROM_ROOT=${!var}
1294 fi
1295
1296 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1297}
1298
1299# this is used internally by the cdrom_get_cds() and cdrom_load_next_cd()
1300# functions. this should *never* be called from an ebuild.
1301# all it does is try to locate a give file on a cd ... if the cd isn't
1302# found, then a message asking for the user to insert the cdrom will be
1303# displayed and we'll hang out here until:
1304# (1) the file is found on a mounted cdrom
1305# (2) the user hits CTRL+C
1306_cdrom_locate_file_on_cd() {
1307 local mline=""
1308 local showedmsg=0 showjolietmsg=0
1309
1310 while [[ -z ${CDROM_ROOT} ]] ; do
1311 local i=0
1312 local -a cdset=(${*//:/ })
1313 if [[ -n ${CDROM_SET} ]] ; then
1314 cdset=(${cdset[${CDROM_SET}]})
1315 fi
1316
1317 while [[ -n ${cdset[${i}]} ]] ; do
1318 local dir=$(dirname ${cdset[${i}]})
1319 local file=$(basename ${cdset[${i}]})
1320
1321 local point= node= fs= foo=
1322 while read point node fs foo ; do
1323 [[ " cd9660 iso9660 udf " != *" ${fs} "* ]] && \
1324 ! [[ ${fs} == "subfs" && ",${opts}," == *",fs=cdfss,"* ]] \
1325 && continue
1326 point=${point//\040/ }
1327 [[ ! -d ${point}/${dir} ]] && continue
1328 [[ -z $(find "${point}/${dir}" -maxdepth 1 -iname "${file}") ]] && continue
1329 export CDROM_ROOT=${point}
1330 export CDROM_SET=${i}
1331 export CDROM_MATCH=${cdset[${i}]}
1332 return
1333 done <<< "$(get_mounts)"
1334
1335 ((++i))
1336 done
1337
1338 echo
1339 if [[ ${showedmsg} -eq 0 ]] ; then
1340 if [[ ${CDROM_TOTAL_CDS} -eq 1 ]] ; then
1341 if [[ -z ${CDROM_NAME} ]] ; then
1342 einfo "Please insert+mount the cdrom for ${PN} now !"
1343 else
1344 einfo "Please insert+mount the ${CDROM_NAME} cdrom now !"
1345 fi
1346 else
1347 if [[ -z ${CDROM_NAME_1} ]] ; then
1348 einfo "Please insert+mount cd #${CDROM_CURRENT_CD} for ${PN} now !"
1349 else
1350 local var="CDROM_NAME_${CDROM_CURRENT_CD}"
1351 einfo "Please insert+mount the ${!var} cdrom now !"
1352 fi
1353 fi
1354 showedmsg=1
1355 fi
1356 einfo "Press return to scan for the cd again"
1357 einfo "or hit CTRL+C to abort the emerge."
1358 echo
1359 if [[ ${showjolietmsg} -eq 0 ]] ; then
1360 showjolietmsg=1
1361 else
1362 ewarn "If you are having trouble with the detection"
1363 ewarn "of your CD, it is possible that you do not have"
1364 ewarn "Joliet support enabled in your kernel. Please"
1365 ewarn "check that CONFIG_JOLIET is enabled in your kernel."
1366 ebeep 5
1367 fi
1368 read || die "something is screwed with your system"
1369 done
1370}
1371
1372# @FUNCTION: strip-linguas
1373# @USAGE: [<allow LINGUAS>|<-i|-u> <directories of .po files>]
1374# @DESCRIPTION:
1375# Make sure that LINGUAS only contains languages that
1376# a package can support. The first form allows you to
1377# specify a list of LINGUAS. The -i builds a list of po
1378# files found in all the directories and uses the
1379# intersection of the lists. The -u builds a list of po
1380# files found in all the directories and uses the union
1381# of the lists.
1382strip-linguas() {
1383 local ls newls nols
1384 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then
1385 local op=$1; shift
1386 ls=$(find "$1" -name '*.po' -exec basename {} .po ';'); shift
1387 local d f
1388 for d in "$@" ; do
1389 if [[ ${op} == "-u" ]] ; then
1390 newls=${ls}
1391 else
1392 newls=""
1393 fi
1394 for f in $(find "$d" -name '*.po' -exec basename {} .po ';') ; do
1395 if [[ ${op} == "-i" ]] ; then
1396 has ${f} ${ls} && newls="${newls} ${f}"
1397 else
1398 has ${f} ${ls} || newls="${newls} ${f}"
1399 fi
1400 done
1401 ls=${newls}
1402 done
1403 else
1404 ls="$@"
1405 fi
1406
1407 nols=""
1408 newls=""
1409 for f in ${LINGUAS} ; do
1410 if has ${f} ${ls} ; then
1411 newls="${newls} ${f}"
1412 else
1413 nols="${nols} ${f}"
1414 fi
1415 done
1416 [[ -n ${nols} ]] \
1417 && ewarn "Sorry, but ${PN} does not support the LINGUAS:" ${nols}
1418 export LINGUAS=${newls:1}
1419}
1420
1421# @FUNCTION: preserve_old_lib
1422# @USAGE: <libs to preserve> [more libs]
1423# @DESCRIPTION:
1424# These functions are useful when a lib in your package changes ABI SONAME.
1425# An example might be from libogg.so.0 to libogg.so.1. Removing libogg.so.0
1426# would break packages that link against it. Most people get around this
1427# by using the portage SLOT mechanism, but that is not always a relevant
1428# solution, so instead you can call this from pkg_preinst. See also the
1429# preserve_old_lib_notify function.
1430preserve_old_lib() {
1431 if [[ ${EBUILD_PHASE} != "preinst" ]] ; then
1432 eerror "preserve_old_lib() must be called from pkg_preinst() only"
1433 die "Invalid preserve_old_lib() usage"
1434 fi
1435 [[ -z $1 ]] && die "Usage: preserve_old_lib <library to preserve> [more libraries to preserve]"
1436
1437 # let portage worry about it
1438 has preserve-libs ${FEATURES} && return 0
1439
1440 local lib dir
1441 for lib in "$@" ; do
1442 [[ -e ${ROOT}/${lib} ]] || continue
1443 dir=${lib%/*}
1444 dodir ${dir} || die "dodir ${dir} failed"
1445 cp "${ROOT}"/${lib} "${D}"/${lib} || die "cp ${lib} failed"
1446 touch "${D}"/${lib}
1447 done
1448}
1449
1450# @FUNCTION: preserve_old_lib_notify
1451# @USAGE: <libs to notify> [more libs]
1452# @DESCRIPTION:
1453# Spit helpful messages about the libraries preserved by preserve_old_lib.
1454preserve_old_lib_notify() {
1455 if [[ ${EBUILD_PHASE} != "postinst" ]] ; then
1456 eerror "preserve_old_lib_notify() must be called from pkg_postinst() only"
1457 die "Invalid preserve_old_lib_notify() usage"
1458 fi
1459
1460 # let portage worry about it
1461 has preserve-libs ${FEATURES} && return 0
1462
1463 local lib notice=0
1464 for lib in "$@" ; do
1465 [[ -e ${ROOT}/${lib} ]] || continue
1466 if [[ ${notice} -eq 0 ]] ; then
1467 notice=1
1468 ewarn "Old versions of installed libraries were detected on your system."
1469 ewarn "In order to avoid breaking packages that depend on these old libs,"
1470 ewarn "the libraries are not being removed. You need to run revdep-rebuild"
1471 ewarn "in order to remove these old dependencies. If you do not have this"
1472 ewarn "helper program, simply emerge the 'gentoolkit' package."
1473 ewarn
1474 fi
1475 # temp hack for #348634 #357225
1476 [[ ${PN} == "mpfr" ]] && lib=${lib##*/}
1477 ewarn " # revdep-rebuild --library '${lib}'"
1478 done
1479 if [[ ${notice} -eq 1 ]] ; then
1480 ewarn
1481 ewarn "Once you've finished running revdep-rebuild, it should be safe to"
1482 ewarn "delete the old libraries. Here is a copy & paste for the lazy:"
1483 for lib in "$@" ; do
1484 ewarn " # rm '${lib}'"
1485 done
1486 fi
1487}
1488
1489# @FUNCTION: built_with_use
1490# @USAGE: [--hidden] [--missing <action>] [-a|-o] <DEPEND ATOM> <List of USE flags>
1491# @DESCRIPTION:
1492#
1493# Deprecated: Use EAPI 2 use deps in DEPEND|RDEPEND and with has_version calls.
1494#
1495# A temporary hack until portage properly supports DEPENDing on USE
1496# flags being enabled in packages. This will check to see if the specified
1497# DEPEND atom was built with the specified list of USE flags. The
1498# --missing option controls the behavior if called on a package that does
1499# not actually support the defined USE flags (aka listed in IUSE).
1500# The default is to abort (call die). The -a and -o flags control
1501# the requirements of the USE flags. They correspond to "and" and "or"
1502# logic. So the -a flag means all listed USE flags must be enabled
1503# while the -o flag means at least one of the listed IUSE flags must be
1504# enabled. The --hidden option is really for internal use only as it
1505# means the USE flag we're checking is hidden expanded, so it won't be found
1506# in IUSE like normal USE flags.
1507#
1508# Remember that this function isn't terribly intelligent so order of optional
1509# flags matter.
1510built_with_use() {
1511 local hidden="no"
1512 if [[ $1 == "--hidden" ]] ; then
1513 hidden="yes"
1514 shift
1515 fi
1516
1517 local missing_action="die"
1518 if [[ $1 == "--missing" ]] ; then
1519 missing_action=$2
1520 shift ; shift
1521 case ${missing_action} in
1522 true|false|die) ;;
1523 *) die "unknown action '${missing_action}'";;
1524 esac
1525 fi
1526
1527 local opt=$1
1528 [[ ${opt:0:1} = "-" ]] && shift || opt="-a"
1529
1530 local PKG=$(best_version $1)
1531 [[ -z ${PKG} ]] && die "Unable to resolve $1 to an installed package"
1532 shift
1533
1534 local USEFILE=${ROOT}/var/db/pkg/${PKG}/USE
1535 local IUSEFILE=${ROOT}/var/db/pkg/${PKG}/IUSE
1536
1537 # if the IUSE file doesn't exist, the read will error out, we need to handle
1538 # this gracefully
1539 if [[ ! -e ${USEFILE} ]] || [[ ! -e ${IUSEFILE} && ${hidden} == "no" ]] ; then
1540 case ${missing_action} in
1541 true) return 0;;
1542 false) return 1;;
1543 die) die "Unable to determine what USE flags $PKG was built with";;
1544 esac
1545 fi
1546
1547 if [[ ${hidden} == "no" ]] ; then
1548 local IUSE_BUILT=( $(<"${IUSEFILE}") )
1549 # Don't check USE_EXPAND #147237
1550 local expand
1551 for expand in $(echo ${USE_EXPAND} | tr '[:upper:]' '[:lower:]') ; do
1552 if [[ $1 == ${expand}_* ]] ; then
1553 expand=""
1554 break
1555 fi
1556 done
1557 if [[ -n ${expand} ]] ; then
1558 if ! has $1 ${IUSE_BUILT[@]#[-+]} ; then
1559 case ${missing_action} in
1560 true) return 0;;
1561 false) return 1;;
1562 die) die "$PKG does not actually support the $1 USE flag!";;
1563 esac
1564 fi
1565 fi
1566 fi
1567
1568 local USE_BUILT=$(<${USEFILE})
1569 while [[ $# -gt 0 ]] ; do
1570 if [[ ${opt} = "-o" ]] ; then
1571 has $1 ${USE_BUILT} && return 0
1572 else
1573 has $1 ${USE_BUILT} || return 1
1574 fi
1575 shift
1576 done
1577 [[ ${opt} = "-a" ]]
1578}
1579
1580# @FUNCTION: epunt_cxx
1581# @USAGE: [dir to scan]
1582# @DESCRIPTION:
1583# Many configure scripts wrongly bail when a C++ compiler could not be
1584# detected. If dir is not specified, then it defaults to ${S}.
1585#
1586# http://bugs.gentoo.org/73450
1587epunt_cxx() {
1588 local dir=$1
1589 [[ -z ${dir} ]] && dir=${S}
1590 ebegin "Removing useless C++ checks"
1591 local f
1592 find "${dir}" -name configure | while read f ; do
1593 patch --no-backup-if-mismatch -p0 "${f}" "${PORTDIR}/eclass/ELT-patches/nocxx/nocxx.patch" > /dev/null
1594 done
1595 eend 0
1596}
1597
1598# @FUNCTION: make_wrapper
1599# @USAGE: <wrapper> <target> [chdir] [libpaths] [installpath]
1600# @DESCRIPTION:
1601# Create a shell wrapper script named wrapper in installpath
1602# (defaults to the bindir) to execute target (default of wrapper) by
1603# first optionally setting LD_LIBRARY_PATH to the colon-delimited
1604# libpaths followed by optionally changing directory to chdir.
1605make_wrapper() {
1606 local wrapper=$1 bin=$2 chdir=$3 libdir=$4 path=$5
1607 local tmpwrapper=$(emktemp)
1608 # We don't want to quote ${bin} so that people can pass complex
1609 # things as $bin ... "./someprog --args"
1610 cat << EOF > "${tmpwrapper}"
1611#!/bin/sh
1612cd "${chdir:-.}"
1613if [ -n "${libdir}" ] ; then
1614 if [ "\${LD_LIBRARY_PATH+set}" = "set" ] ; then
1615 export LD_LIBRARY_PATH="\${LD_LIBRARY_PATH}:${libdir}"
1616 else
1617 export LD_LIBRARY_PATH="${libdir}"
1618 fi
1619fi
1620exec ${bin} "\$@"
1621EOF
1622 chmod go+rx "${tmpwrapper}"
1623 if [[ -n ${path} ]] ; then
1624 (
1625 exeinto "${path}"
1626 newexe "${tmpwrapper}" "${wrapper}"
1627 ) || die
1628 else
1629 newbin "${tmpwrapper}" "${wrapper}" || die
1630 fi
1631}
1632
1633# @FUNCTION: path_exists
1634# @USAGE: [-a|-o] <paths>
1635# @DESCRIPTION:
1636# Check if the specified paths exist. Works for all types of paths
1637# (files/dirs/etc...). The -a and -o flags control the requirements
1638# of the paths. They correspond to "and" and "or" logic. So the -a
1639# flag means all the paths must exist while the -o flag means at least
1640# one of the paths must exist. The default behavior is "and". If no
1641# paths are specified, then the return value is "false".
1642path_exists() {
1643 local opt=$1
1644 [[ ${opt} == -[ao] ]] && shift || opt="-a"
1645
1646 # no paths -> return false
1647 # same behavior as: [[ -e "" ]]
1648 [[ $# -eq 0 ]] && return 1
1649
1650 local p r=0
1651 for p in "$@" ; do
1652 [[ -e ${p} ]]
1653 : $(( r += $? ))
1654 done
1655
1656 case ${opt} in
1657 -a) return $(( r != 0 )) ;;
1658 -o) return $(( r == $# )) ;;
1659 esac
1660}
1661
1662# @FUNCTION: in_iuse
1663# @USAGE: <flag>
1664# @DESCRIPTION:
1665# Determines whether the given flag is in IUSE. Strips IUSE default prefixes
1666# as necessary.
1667#
1668# Note that this function should not be used in the global scope.
1669in_iuse() {
1670 debug-print-function ${FUNCNAME} "${@}"
1671 [[ ${#} -eq 1 ]] || die "Invalid args to ${FUNCNAME}()"
1672
1673 local flag=${1}
1674 local liuse=( ${IUSE} )
1675
1676 has "${flag}" "${liuse[@]#[+-]}"
1677}
1678
1679# @FUNCTION: use_if_iuse
1680# @USAGE: <flag>
1681# @DESCRIPTION:
1682# Return true if the given flag is in USE and IUSE.
1683#
1684# Note that this function should not be used in the global scope.
1685use_if_iuse() {
1686 in_iuse $1 || return 1
1687 use $1
1688}
1689
1690# @FUNCTION: usex
1691# @USAGE: <USE flag> [true output] [false output] [true suffix] [false suffix]
1692# @DESCRIPTION:
1693# If USE flag is set, echo [true output][true suffix] (defaults to "yes"),
1694# otherwise echo [false output][false suffix] (defaults to "no").
1695usex() { use "$1" && echo "${2-yes}$4" || echo "${3-no}$5" ; } #382963
1696
1697check_license() { die "you no longer need this as portage supports ACCEPT_LICENSE itself"; }
1698
1699fi

Legend:
Removed from v.1.62  
changed lines
  Added in v.1.373

  ViewVC Help
Powered by ViewVC 1.1.20